
'use strict'
$(document).ready(function () {
    // TODO: Add your JavaScript code here.
    //       If this function is called, the HTML is loaded and complete.
    //       You can now run scripts or manipulate HTML contents.
    $('#focused-file').text('No file received yet');
    console.log('Hello world');
});

IMWS.get('v1/files', {
    // Information about the focused file in the active file window.
    idlist: IMatch.idlist.fileWindowFocusedFile,
    fields: 'id,filename,name,namene,ext'
}).then(function (response) {
    var path = '';
    if (response.files.length > 0) {
        $('#focused-file').text(response.files[0].fileName);


        getAttribute(response.files[0]);
        //SetAttribute(response.files[0]);
    }
    else {
        alert('no focused file')
    }
});


$('#focused-file').text('No file received yet');



function getAttribute(afile) {
    IMWS.get('v1/attributes', {
        setid: 1,
        // The idlist parameter is only evaluated when we retrieve data for a per-file set.
        // to know what to put here look at webservices documentation AND
        // run the sample app "attributes" which shows you the data structure.
        id: afile.id,
        resolverefs: false
    }).then(function (response) {
        console.log('get attrib returns:' + JSON.stringify(response, null, 2));
        /*  returns the following for my case
        {
  "result": [
    {
      "id": 750994,
      "data": [
        {
          "instanceId": 1,
          "PageSequenceNr": "123"
        }
      ]
    }
  ],
  "debug": {
    "runtime": "0ms"
  }
}
        */
        if (response.result.length != 0) {
            console.log('Attribute returned (PageSequenceNr):' + response.result[0].data[0].PageSequenceNr);
            if (response.result[0].data.length > 1) {
                alert('More than one values for this attribute - can not handle this!');
                IMatch.modalClose();
            };
            SetAttribute(afile, 'replace');// exists thus update
        }
        else {
            SetAttribute(afile, 'add'); // does not yet exist thus add
        }

    },


        function (error) {
            console.log('Error:' + error);

        });
}
function SetAttribute(afile, AddOrUpdate) {
    // code cloned from attributes sample script
    var params = {
        // Which set to add records to?
        setid: 1

    }
    var actions = [];
   
    var action = {
        // We add a record
        op: AddOrUpdate,          // replace only works if it exists!
        // This contains the data we add. 
        // One value for each attribute in the set.
        // If an attribute is not specified, it will be added
        // as null or with the default value (if one is defined)
        data: {}
    }

    action.data.PageSequenceNr = 'HellO';

   
    action.data.instanceid = 1; 
  
    params.id = afile.id;
    
    actions.push(action);  //I have only one so I could use actions[0] = action
    // Convert data into a string to send it to IMWS
    params.actions = JSON.stringify(actions);
    //debugger;
    console.log('This is sent to the server: ' + JSON.stringify(params));

    // TIP: Look at params in the debugger of your browser
    //      to see what is sent to the server.

    IMWS.post('v1/attributes', params).then(function (response) {
        //console.log(JSON.stringify(response, null, 2));
        console.log('Set attrib returns:' + JSON.stringify(response, null, 2));
        console.log(' attribute setting returned OK');

    },
        function (error) {
            console.log(error);

        });


}

